      PROGRAM TPZGESV
*
*       ணࠬ PZGESV
*
      include 'mpif.h'
*  ⠭ - ࠬ  ..
      INTEGER            DLEN_, IA, JA, IB, JB, M, N, MB, NB, RSRC,
     $                   CSRC, MXLLDA, MXLLDB, NRHS, NBRHS, NOUT,
     $                   MXLOCR, MXLOCC, MXRHSC
      PARAMETER          ( DLEN_ = 9, IA = 1, JA = 1, IB = 1, JB = 1,
     $                   M = 9, N = 9, MB = 2, NB = 2, RSRC = 0,
     $                   CSRC = 0, MXLLDA = 5, MXLLDB = 5, NRHS = 1,
     $                   NBRHS = 1, NOUT = 6, MXLOCR = 5, MXLOCC = 4,
     $                   MXRHSC = 1 )
      DOUBLE COMPLEX   ONE
      PARAMETER          ( ONE = (1.0D+0,0.D0) )
*
*  ६ ..
      INTEGER            ICTXT, INFO, MYCOL, MYROW, NPCOL, NPROW
      DOUBLE PRECISION   ANORM, BNORM, EPS, RESID, XNORM
*
*  ᨢ ..
      INTEGER            DESCA( DLEN_ ), DESCB( DLEN_ ),
     $                   IPIV( MXLOCR+NB )
      DOUBLE COMPLEX     A( MXLLDA, MXLOCC ), A0( MXLLDA, MXLOCC ),
     $                   B( MXLLDB, MXRHSC ), B0( MXLLDB, MXRHSC ),
     $                   WORK1( MB )
      DOUBLE PRECISION   WORK( MXLOCR )
*
* 譨 㭪樨 ..
      DOUBLE PRECISION   PDLAMCH, PZLANGE
      EXTERNAL           PDLAMCH, PZLANGE
*
* 譨 ணࠬ ..
      EXTERNAL           BLACS_EXIT, BLACS_GRIDEXIT, BLACS_GRIDINFO,
     $                   DESCINIT, MATINIT, PZGEMM, PZGESV, PZLACPY,
     $                   PZLAPRNT, SL_INIT
*
* ७ 㭪樨 ..
      INTRINSIC          DBLE
*
*   DATA ..
      DATA               NPROW / 2 / , NPCOL / 3 /
*
* 믮  ..
*
* 樠 ⪨ ᮢ
*
      CALL SL_INIT( ICTXT, NPROW, NPCOL )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
*
* ᫨   ⪨ ᮢ, 室   ணࠬ
*
      IF( MYROW.EQ.-1 ) GO TO 10
*
* ।   ⪥ ᮢ
*
* 樠 ਯ஢   A  B
*
      CALL DESCINIT( DESCA, M, N, MB, NB, RSRC, CSRC, ICTXT, MXLLDA,
     $               INFO )
      CALL DESCINIT( DESCB, N, NRHS, NB, NBRHS, RSRC, CSRC, ICTXT,
     $               MXLLDB, INFO )
*
*      CALL BLACS_BARRIER( ICTXT, 'R' )
*
*   A  B  ।  ⪥ ᮢ
*
      CALL MATINIT( A, DESCA, B, DESCB )
*
* ஢ A  B  ஢ન 離
*
      CALL PZLACPY( 'All', N, N, A, 1, 1, DESCA, A0, 1, 1, DESCA )
      CALL PZLACPY( 'All', N, NRHS, B, 1, 1, DESCB, B0, 1, 1, DESCB )
*
*  室 
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = 9999 )
         WRITE( NOUT, FMT = 9998 )M, N, MB, NB
         WRITE( NOUT, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NOUT, FMT = * ) ' 室  '
         WRITE( NOUT, FMT = * ) '  DESCA'
         WRITE( NOUT, FMT = 9985 )DESCA
         WRITE( NOUT, FMT = * ) '  DESCB'
         WRITE( NOUT, FMT = 9985 )DESCB
         WRITE( NOUT, FMT = * ) ' A'
      END IF
 9985 FORMAT( / 9I5 /)
*
      CALL PZLAPRNT( M, N, A, IA, JA, DESCA, 0, 0, 'A', NOUT, WORK1 )

*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
      WRITE( NOUT, FMT = * ) ' B'
      END IF
      CALL PZLAPRNT( N, NRHS, B, IB, JB, DESCB, 0, 0, 'B', NOUT, WORK1 )
*
* 맮 ணࠬ 
*
* 襭  ⥬ A * X = B
*
      CALL PZGESV( N, NRHS, A, IA, JA, DESCA, IPIV, B, IB, JB, DESCB,
     $             INFO )
*
*  १⮢ X 
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) '  '
         WRITE( NOUT, FMT = 9996 )INFO
         WRITE( NOUT, FMT = * ) '襭 X'
      END IF
*
      CALL PZLAPRNT( N, NRHS, B, IB, JB, DESCB, 0, 0, 'X', NOUT, WORK1 )
*
* ᫥ 離 ||A * X  - B|| / ( ||X|| * ||A|| * eps * N )
*
      EPS = PDLAMCH( ICTXT, 'Epsilon' )
      ANORM = PZLANGE( 'I', N, N, A, 1, 1, DESCA, WORK )
      BNORM = PZLANGE( 'I', N, NRHS, B, 1, 1, DESCB, WORK )
      CALL PZGEMM( 'N', 'N', N, NRHS, N, ONE, A0, 1, 1, DESCA, B, 1, 1,
     $             DESCB, -ONE, B0, 1, 1, DESCB )
      XNORM = PZLANGE( 'I', N, NRHS, B0, 1, 1, DESCB, WORK )
      RESID = XNORM / ( ANORM*BNORM*EPS*DBLE( N ) )
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         IF( RESID.LT.10.0D+0 ) THEN
            WRITE( NOUT, FMT = 9995 )
            WRITE( NOUT, FMT = 9993 )RESID
         ELSE
            WRITE( NOUT, FMT = 9994 )
            WRITE( NOUT, FMT = 9993 )RESID
         END IF
      END IF
*
* ᢮  ⪨ ᮢ
*
* ᢮ ⥪ BLACS'
*
      CALL BLACS_GRIDEXIT( ICTXT )
   10 CONTINUE
*
* 室  BLACS
*
      CALL BLACS_EXIT( 0 )
*
 9999 FORMAT( / '   ணࠬ PZGESV' )
 9998 FORMAT(/' 襭 A X = B ,'//'  A - ᭠  ',
     $ I2,' ',I2,',',
     $       /'      ࠧ  ', I2, '  ', I2, /)
 9997 FORMAT( ' ய  ', I2, ' ,',
     $       ' ࠧ  ࠧ஬ ', I2, '  ', I2 /)
 9996 FORMAT( / ' 祭 INFO  = ', I6 /)
 9995 FORMAT( /' 離 ')
 9994 FORMAT( /' 離 ')
 9993 FORMAT( / '||A*x - b|| / ( ||x||*||A||*eps*N ) = ', 1P, E16.8 )
      STOP
      END
*
      SUBROUTINE MATINIT( AA, DESCA, B, DESCB )
*
* MATINIT   ।  A  B
*          ⪥ ᮢ 2 x 3
*
* ࠬ - ᨢ ..
      INTEGER            DESCA( * ), DESCB( * )
      DOUBLE COMPLEX     AA( * ), B( * )
*
* Parameters ..
      INTEGER            CTXT_, LLD_
      PARAMETER          ( CTXT_ = 2, LLD_ = 9 )
*
*  ६ ..
*
      INTEGER            ICTXT, MXLLDA, MYCOL, MYROW, NPCOL, NPROW
      DOUBLE COMPLEX     A, C, K, L, P, S
*
* 譨 ணࠬ ..
      EXTERNAL           BLACS_GRIDINFO
*
*
* 믮  ..
*
      ICTXT = DESCA( CTXT_ )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
*
      S = (19.0D0, 0.D0)
      C = (3.0D0, 0.D0)
      A = (1.0D0, 0.D0)
      L = (12.0D0, 0.D0)
      P = (16.0D0, 0.D0)
      K = (11.0D0, 0.D0)
*
      MXLLDA = DESCA( LLD_ )
*
*    A  B   (0, 0)
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         AA( 1 ) = S
         AA( 2 ) = -S
         AA( 3 ) = -S
         AA( 4 ) = -S
         AA( 5 ) = -S
         AA( 1+MXLLDA ) = C
         AA( 2+MXLLDA ) = C
         AA( 3+MXLLDA ) = -C
         AA( 4+MXLLDA ) = -C
         AA( 5+MXLLDA ) = -C
         AA( 1+2*MXLLDA ) = A
         AA( 2+2*MXLLDA ) = A
         AA( 3+2*MXLLDA ) = A
         AA( 4+2*MXLLDA ) = A
         AA( 5+2*MXLLDA ) = -A
         AA( 1+3*MXLLDA ) = C
         AA( 2+3*MXLLDA ) = C
         AA( 3+3*MXLLDA ) = C
         AA( 4+3*MXLLDA ) = C
         AA( 5+3*MXLLDA ) = -C
*
         B( 1 ) = (0.0D0, 0.D0)
         B( 2 ) = (0.0D0, 0.D0)
         B( 3 ) = (0.0D0, 0.D0)
         B( 4 ) = (0.0D0, 0.D0)
         B( 5 ) = (0.0D0, 0.D0)
*
* 쭠   A   (0, 1)
*
      ELSE IF( MYROW.EQ.0 .AND. MYCOL.EQ.1 ) THEN
         AA( 1 ) = A
         AA( 2 ) = A
         AA( 3 ) = -A
         AA( 4 ) = -A
         AA( 5 ) = -A
         AA( 1+MXLLDA ) = L
         AA( 2+MXLLDA ) = L
         AA( 3+MXLLDA ) = -L
         AA( 4+MXLLDA ) = -L
         AA( 5+MXLLDA ) = -L
         AA( 1+2*MXLLDA ) = K
         AA( 2+2*MXLLDA ) = K
         AA( 3+2*MXLLDA ) = K
         AA( 4+2*MXLLDA ) = K
         AA( 5+2*MXLLDA ) = K
*
* 쭠   A   (0, 2)
*
      ELSE IF( MYROW.EQ.0 .AND. MYCOL.EQ.2 ) THEN
         AA( 1 ) = A
         AA( 2 ) = A
         AA( 3 ) = A
         AA( 4 ) = -A
         AA( 5 ) = -A
         AA( 1+MXLLDA ) = P
         AA( 2+MXLLDA ) = P
         AA( 3+MXLLDA ) = P
         AA( 4+MXLLDA ) = P
         AA( 5+MXLLDA ) = -P
*
*    A  B   (1, 0)
*
      ELSE IF( MYROW.EQ.1 .AND. MYCOL.EQ.0 ) THEN
         AA( 1 ) = -S
         AA( 2 ) = -S
         AA( 3 ) = -S
         AA( 4 ) = -S
         AA( 1+MXLLDA ) = -C
         AA( 2+MXLLDA ) = -C
         AA( 3+MXLLDA ) = -C
         AA( 4+MXLLDA ) = C
         AA( 1+2*MXLLDA ) = A
         AA( 2+2*MXLLDA ) = A
         AA( 3+2*MXLLDA ) = A
         AA( 4+2*MXLLDA ) = -A
         AA( 1+3*MXLLDA ) = C
         AA( 2+3*MXLLDA ) = C
         AA( 3+3*MXLLDA ) = C
         AA( 4+3*MXLLDA ) = C
*
         B( 1 ) = (1.0D0, 0.D0)
         B( 2 ) = (0.0D0, 0.D0)
         B( 3 ) = (0.0D0, 0.D0)
         B( 4 ) = (0.0D0, 0.D0)
*
* 쭠   A   (1, 1)
*
      ELSE IF( MYROW.EQ.1 .AND. MYCOL.EQ.1 ) THEN
         AA( 1 ) = A
         AA( 2 ) = -A
         AA( 3 ) = -A
         AA( 4 ) = -A
         AA( 1+MXLLDA ) = L
         AA( 2+MXLLDA ) = L
         AA( 3+MXLLDA ) = -L
         AA( 4+MXLLDA ) = -L
         AA( 1+2*MXLLDA ) = K
         AA( 2+2*MXLLDA ) = K
         AA( 3+2*MXLLDA ) = K
         AA( 4+2*MXLLDA ) = K
*
* 쭠   A   (1, 2)
*
      ELSE IF( MYROW.EQ.1 .AND. MYCOL.EQ.2 ) THEN
         AA( 1 ) = A
         AA( 2 ) = A
         AA( 3 ) = -A
         AA( 4 ) = -A
         AA( 1+MXLLDA ) = P
         AA( 2+MXLLDA ) = P
         AA( 3+MXLLDA ) = -P
         AA( 4+MXLLDA ) = -P
      END IF
      RETURN
      END
